/***************************************************************************
                          blockbtn.cpp  -  description
                             -------------------
    begin                : Sat May 17 2003
    copyright            : (C) 2003 by Marcus Beranek
    email                : marcus@beranek.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

//
// A BlockButton is just a simple QPushButton, except that it also holds
// the ID of the block, it is representing.
//

 
#include "blockbtn.h"
#include <qpushbutton.h>

BlockBtn::BlockBtn(QWidget *parent, const char *name ) : QPushButton(parent,name)
{
  number = 0;
  connect( this, SIGNAL( clicked() ), this, SLOT( slotIwasClicked() ) );
}

BlockBtn::~BlockBtn()
{
}

void BlockBtn::setID(int id)
{
  number = id;
}

int BlockBtn::getID()
{
  return number;
}


void BlockBtn::slotIwasClicked()
{
  emit blockSelected( number );
}
