/***************************************************************************
                          pluginaction.h  -  description
                             -------------------
    begin                : Sun Jun 1 2003
    copyright            : (C) 2003 by Marcus Beranek
    email                : marcus@beranek.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PLUGINACTION_H
#define PLUGINACTION_H

#include <qaction.h>
#include <qobject.h>

class QString;
class QKeySequence;

/**
  *@author Marcus Beranek
  */

class PluginAction : public QAction {

  Q_OBJECT
  
public: 

  PluginAction(
	const QString & text,
	const QString & menuText,
	QKeySequence accel,
	QObject* parent,
	const char * name = 0,
	bool toggle = FALSE );

  ~PluginAction();
  
  void setLibname( QString lib );

signals:
	void pluginActivated( QString pl );

protected slots: // Protected slots
	void firePlugin();

private:
	QString pluginlibname;

};

#endif
