/***************************************************************************
                          prototype.h  -  description
                             -------------------
    begin                : Thu May 15 22:50:15 CEST 2003
    copyright            : (C) 2003 by Marcus Beranek
    email                : marcus@beranek.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PROTOTYPE_H
#define PROTOTYPE_H

// include files for QT
#include <qapp.h>
#include <qmainwindow.h>
#include <qaction.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qtoolbar.h>
#include <qtoolbutton.h>
#include <qstatusbar.h>
#include <qwhatsthis.h>
#include <qstring.h>
#include <qpixmap.h>
#include <qmsgbox.h>
#include <qfiledialog.h>
#include <qprinter.h>
#include <qpainter.h>
#include <qptrlist.h>

// application specific includes
#include "prototypeview.h"
#include "prototypedoc.h"

class Settings;
class QStringList;

class ProtoTypeApp : public QMainWindow
{
	Q_OBJECT

public:
	ProtoTypeApp();
	~ProtoTypeApp();

	void initActions();
	void initMenuBar();
	void initToolBar();
	void initStatusBar();
	void initDoc();
	void initView();

	bool queryExit();

public slots:

	void slotFileNew();
	void slotFileOpen();
	void slotFileSave();
	void slotFileSaveAs();
	void slotFileClose();
	void slotFilePrint();
	void slotFileQuit();
	void slotEditCut();
	void slotEditCopy();
	void slotEditPaste();
	void slotViewToolBar(bool toggle);
	void slotViewStatusBar(bool toggle);
	void slotCompleteProtocol(bool);
	void slotHelpAbout();
	void setConfigMCPL(QString mcpl );
	void setConfigLanguage( QString l );
	void setConfigProtocolPath( QString p );
	void setConfigPluginDir(QString pd );

protected:
	void findPluginLibs();

private:

	ProtoTypeView *view;
	ProtoTypeDoc *doc;

	void readConfig();
	void writeConfigFile();
	void readProtocols();
	QString config_protocol_path;
	int config_max_characters_per_line;
	QString config_language;
	QString config_plugindir;

	QPopupMenu *fileMenu;
	QPopupMenu *editMenu;
	QPopupMenu *viewMenu;
	QPopupMenu *helpMenu;

	QPopupMenu *pluginMenu;

	QToolBar *fileToolbar;

	QAction *fileNew;
	QAction *fileOpen;
	QAction *fileSave;
	QAction *fileSaveAs;
	QAction *fileClose;
	QAction *filePrint;
	QAction *fileQuit;

	QAction *editCut;
	QAction *editCopy;
	QAction *editPaste;

	QAction *viewToolBar;
	QAction *viewStatusBar;
	QAction *viewCompleteProtocol;
	QAction *viewProtocolTree;
	QAction *viewSettings;

	QAction *helpAboutApp;

	Settings *settings;

	QStringList pluginlist;

protected slots:
	void slotSettings();
	void slotPluginSelected( QString pl );

};
#endif

